 ;++
;Copyright (c) Microsoft Corporation. All rights reserved.
;Module Name:
;rpcdce.h
;Abstract:
;This module contains the DCE RPC runtime APIs.
;--*/
IFNDEF __RPCDCE_H__
IF COMPARE (_MSC_VER,GT,1000)
;ECHO   once
ENDIF 
 ;typedef char small;
 ;typedef unsigned char byte;
 ;typedef unsigned char boolean;
;Include \masm32\sdk\specstrings.SDK
rpc_binding_handle_t	equ	<RPC_BINDING_HANDLE>
IFNDEF GUID_DEFINED
;Include \masm32\sdk\guiddef.SDK
ENDIF  ; GUID_DEFINED 
IFNDEF UUID_DEFINED
IFNDEF uuid_t
uuid_t	equ	<UUID>
ENDIF 
ENDIF 

RPC_BINDING_VECTOR	STRUCT
	Count DWORD ?
	BindingH DWORD 1 dup (?)

RPC_BINDING_VECTOR		ENDS

IFNDEF rpc_binding_vector_t
rpc_binding_vector_t	equ	<RPC_BINDING_VECTOR>
ENDIF 

UUID_VECTOR	STRUCT
	Count DWORD ?
	Uuid DWORD 1 dup (?)

UUID_VECTOR		ENDS

IFNDEF uuid_vector_t
uuid_vector_t	equ	<UUID_VECTOR>
ENDIF 
IFNDEF IFID_DEFINED

RPC_IF_ID	STRUCT
	Uuid GUID <> ; UUID <> 
	VersMajor WORD ?
	VersMinor WORD ?

RPC_IF_ID		ENDS

ENDIF 
RPC_C_BINDING_INFINITE_TIMEOUT	equ	<10>
RPC_C_BINDING_MIN_TIMEOUT	equ	<0>
RPC_C_BINDING_DEFAULT_TIMEOUT	equ	<5>
RPC_C_BINDING_MAX_TIMEOUT	equ	<9>
RPC_C_CANCEL_INFINITE_TIMEOUT	equ	< -1>
RPC_C_LISTEN_MAX_CALLS_DEFAULT	equ	<1234>
RPC_C_PROTSEQ_MAX_REQS_DEFAULT	equ	<10>
 ; RPC_POLICY EndpointFlags.
RPC_C_BIND_TO_ALL_NICS	equ	<1>
RPC_C_USE_INTERNET_PORT	equ	<01h>
RPC_C_USE_INTRANET_PORT	equ	<02h>
RPC_C_DONT_FAIL	equ	<04h>
 ; RPC_POLICY EndpointFlags specific to the Falcon/RPC transport:
RPC_C_MQ_TEMPORARY	equ	<00000h>
RPC_C_MQ_PERMANENT	equ	<00001h>
RPC_C_MQ_CLEAR_ON_OPEN	equ	<00002h>
RPC_C_MQ_USE_EXISTING_SECURITY	equ	<00004h>
RPC_C_MQ_AUTHN_LEVEL_NONE	equ	<00000h>
RPC_C_MQ_AUTHN_LEVEL_PKT_INTEGRITY	equ	<00008h>
RPC_C_MQ_AUTHN_LEVEL_PKT_PRIVACY	equ	<00010h>
 ; Client: RpcBindingSetOption() values for the Falcon/RPC transport:
RPC_C_OPT_MQ_DELIVERY	equ	<1>
RPC_C_OPT_MQ_PRIORITY	equ	<2>
RPC_C_OPT_MQ_JOURNAL	equ	<3>
RPC_C_OPT_MQ_ACKNOWLEDGE	equ	<4>
RPC_C_OPT_MQ_AUTHN_SERVICE	equ	<5>
RPC_C_OPT_MQ_AUTHN_LEVEL	equ	<6>
RPC_C_OPT_MQ_TIME_TO_REACH_QUEUE	equ	<7>
RPC_C_OPT_MQ_TIME_TO_BE_RECEIVED	equ	<8>
RPC_C_OPT_BINDING_NONCAUSAL	equ	<9>
RPC_C_OPT_SECURITY_CALLBACK	equ	<10>
RPC_C_OPT_UNIQUE_BINDING	equ	<11>
RPC_C_OPT_CALL_TIMEOUT	equ	<12>
RPC_C_OPT_DONT_LINGER	equ	<13>
RPC_C_OPT_MAX_OPTIONS	equ	<14>
RPC_C_MQ_EXPRESS	equ	<0>
RPC_C_MQ_RECOVERABLE	equ	<1>
RPC_C_MQ_JOURNAL_NONE	equ	<0>
RPC_C_MQ_JOURNAL_DEADLETTER	equ	<1>
RPC_C_MQ_JOURNAL_ALWAYS	equ	<2>
 ; flags for RpcServerInqAuthClientEx
 ;
RPC_C_FULL_CERT_CHAIN	equ	<00001h>
IFDEF RPC_UNICODE_SUPPORTED

RPC_PROTSEQ_VECTORA	STRUCT
	Count DWORD ?
	Protseq DWORD 1 dup (?)

RPC_PROTSEQ_VECTORA		ENDS


RPC_PROTSEQ_VECTORW	STRUCT
	Count DWORD ?
	Protseq DWORD 1 dup (?)

RPC_PROTSEQ_VECTORW		ENDS

IFDEF UNICODE
RPC_PROTSEQ_VECTOR	equ	<RPC_PROTSEQ_VECTORW>
ELSE
RPC_PROTSEQ_VECTOR	equ	<RPC_PROTSEQ_VECTORA>
ENDIF  ; UNICODE 
ELSE

RPC_PROTSEQ_VECTOR	STRUCT
	Count DWORD ?
	Protseq DWORD 1 dup (?)

RPC_PROTSEQ_VECTOR		ENDS

ENDIF  ; RPC_UNICODE_SUPPORTED 

RPC_POLICY	STRUCT
	length1 DWORD ?
	EndpointFlags  DWORD ?
	NICFlags  DWORD ?

RPC_POLICY		ENDS

RPC_MGR_EPV	equ	<void>

RPC_STATS_VECTOR	STRUCT
	Count DWORD ?
	Stats DWORD 1 dup (?)

RPC_STATS_VECTOR		ENDS

RPC_C_STATS_CALLS_IN	equ	<0>
RPC_C_STATS_CALLS_OUT	equ	<1>
RPC_C_STATS_PKTS_IN	equ	<2>
RPC_C_STATS_PKTS_OUT	equ	<3>

RPC_IF_ID_VECTOR	STRUCT
	Count DWORD ?
	IfId DWORD 1 dup (?)

RPC_IF_ID_VECTOR		ENDS

 ; client 
;API
RpcBindingCopy PROTO :DWORD ,:DWORD 
 ; client 
;API
RpcBindingFree PROTO :DWORD 
 ; client 
;API
RpcBindingSetOption PROTO :DWORD ,:DWORD ,:DWORD 
 ; client 
;API
RpcBindingInqOption PROTO :DWORD ,:DWORD ,:DWORD 
 ; client 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcBindingFromStringBindingA PROTO :DWORD ,:DWORD 
;API
RpcBindingFromStringBindingW PROTO :DWORD ,:DWORD 
IFDEF UNICODE
RpcBindingFromStringBinding	equ	<RpcBindingFromStringBindingW>
ELSE
RpcBindingFromStringBinding	equ	<RpcBindingFromStringBindingA>
ENDIF  ; UNICODE 
ELSE
;API
RpcBindingFromStringBinding PROTO :DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; client 
;API
RpcSsGetContextBinding PROTO :DWORD ,:DWORD 
 ; client/server 
;API
RpcBindingInqObject PROTO :DWORD ,:DWORD 
 ; client 
;API
RpcBindingReset PROTO :DWORD 
 ; RpcBindingServerFromClient : UNSUPPORTED 
 ; RpcBindingSetAuthInfo 
 ; client 
;API
RpcBindingSetObject PROTO :DWORD ,:DWORD 
 ; client/server 
;API
RpcMgmtInqDefaultProtectLevel PROTO :DWORD ,:DWORD 
 ; client/server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcBindingToStringBindingA PROTO :DWORD ,:DWORD 
;API
RpcBindingToStringBindingW PROTO :DWORD ,:DWORD 
IFDEF UNICODE
RpcBindingToStringBinding	equ	<RpcBindingToStringBindingW>
ELSE
RpcBindingToStringBinding	equ	<RpcBindingToStringBindingA>
ENDIF  ; UNICODE 
ELSE
;API
RpcBindingToStringBinding PROTO :DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; client/server 
;API
RpcBindingVectorFree PROTO :DWORD 
 ; client/server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcStringBindingComposeA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcStringBindingComposeW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcStringBindingCompose	equ	<RpcStringBindingComposeW>
ELSE
RpcStringBindingCompose	equ	<RpcStringBindingComposeA>
ENDIF  ; UNICODE 
ELSE
;API
RpcStringBindingCompose PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; client/server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcStringBindingParseA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcStringBindingParseW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcStringBindingParse	equ	<RpcStringBindingParseW>
ELSE
RpcStringBindingParse	equ	<RpcStringBindingParseA>
ENDIF  ; UNICODE 
ELSE
;API
RpcStringBindingParse PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; client/server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcStringFreeA PROTO :DWORD 
;API
RpcStringFreeW PROTO :DWORD 
IFDEF UNICODE
RpcStringFree	equ	<RpcStringFreeW>
ELSE
RpcStringFree	equ	<RpcStringFreeA>
ENDIF  ; UNICODE 
ELSE
;API
RpcStringFree PROTO :DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; client/server 
;API
RpcIfInqId PROTO :DWORD ,:DWORD 
 ; client/server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcNetworkIsProtseqValidA PROTO :DWORD 
;API
RpcNetworkIsProtseqValidW PROTO :DWORD 
IFDEF UNICODE
RpcNetworkIsProtseqValid	equ	<RpcNetworkIsProtseqValidW>
ELSE
RpcNetworkIsProtseqValid	equ	<RpcNetworkIsProtseqValidA>
ENDIF  ; UNICODE 
ELSE
;API
RpcNetworkIsProtseqValid PROTO :DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; client 
;API
RpcMgmtInqComTimeout PROTO :DWORD ,:DWORD 
 ; client 
;API
RpcMgmtSetComTimeout PROTO :DWORD ,:DWORD 
 ; client 
;API
RpcMgmtSetCancelTimeout PROTO :DWORD 
 ; server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcNetworkInqProtseqsA PROTO :DWORD 
;API
RpcNetworkInqProtseqsW PROTO :DWORD 
IFDEF UNICODE
RpcNetworkInqProtseqs	equ	<RpcNetworkInqProtseqsW>
ELSE
RpcNetworkInqProtseqs	equ	<RpcNetworkInqProtseqsA>
ENDIF  ; UNICODE 
ELSE
;API
RpcNetworkInqProtseqs PROTO :DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; server 
;API
RpcObjectInqType PROTO :DWORD ,:DWORD 
 ; server 
;API
RpcObjectSetInqFn PROTO :DWORD 
 ; server 
;API
RpcObjectSetType PROTO :DWORD ,:DWORD 
 ; server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcProtseqVectorFreeA PROTO :DWORD 
;API
RpcProtseqVectorFreeW PROTO :DWORD 
IFDEF UNICODE
RpcProtseqVectorFree	equ	<RpcProtseqVectorFreeW>
ELSE
RpcProtseqVectorFree	equ	<RpcProtseqVectorFreeA>
ENDIF  ; UNICODE 
ELSE
;API
RpcProtseqVectorFree PROTO :DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; server 
;API
RpcServerInqBindings PROTO :DWORD 
 ; server 
;API
 ; server 
;API
RpcServerListen PROTO :DWORD ,:DWORD ,:DWORD 
 ; server 
;API
RpcServerRegisterIf PROTO :DWORD ,:DWORD ,:DWORD 
 ; server 
;API
RpcServerRegisterIfEx PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ; server 
;API
RpcServerRegisterIf2 PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
 ; server 
;API
 ; server 
;API
 ; server 
;API
RpcServerUseAllProtseqs PROTO :DWORD ,:DWORD 
 ; server 
;API
RpcServerUseAllProtseqsEx PROTO :DWORD ,:DWORD ,:DWORD 
 ; server 
;API
RpcServerUseAllProtseqsIf PROTO :DWORD ,:DWORD ,:DWORD 
 ; server 
;API
RpcServerUseAllProtseqsIfEx PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
 ; server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcServerUseProtseqA PROTO :DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqExA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqW PROTO :DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqExW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcServerUseProtseq	equ	<RpcServerUseProtseqW>
RpcServerUseProtseqEx	equ	<RpcServerUseProtseqExW>
ELSE
RpcServerUseProtseq	equ	<RpcServerUseProtseqA>
RpcServerUseProtseqEx	equ	<RpcServerUseProtseqExA>
ENDIF  ; UNICODE 
ELSE
;API
RpcServerUseProtseq PROTO :DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqEx PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcServerUseProtseqEpA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqEpExA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqEpW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqEpExW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcServerUseProtseqEp	equ	<RpcServerUseProtseqEpW>
RpcServerUseProtseqEpEx	equ	<RpcServerUseProtseqEpExW>
ELSE
RpcServerUseProtseqEp	equ	<RpcServerUseProtseqEpA>
RpcServerUseProtseqEpEx	equ	<RpcServerUseProtseqEpExA>
ENDIF  ; UNICODE 
ELSE
;API
RpcServerUseProtseqEp PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqEpEx PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; server 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcServerUseProtseqIfA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqIfExA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqIfW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqIfExW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcServerUseProtseqIf	equ	<RpcServerUseProtseqIfW>
RpcServerUseProtseqIfEx	equ	<RpcServerUseProtseqIfExW>
ELSE
RpcServerUseProtseqIf	equ	<RpcServerUseProtseqIfA>
RpcServerUseProtseqIfEx	equ	<RpcServerUseProtseqIfExA>
ENDIF  ; UNICODE 
ELSE
;API
RpcServerUseProtseqIf PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerUseProtseqIfEx PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
;API
RpcServerYield PROTO 
 ; server 
;API
RpcMgmtStatsVectorFree PROTO :DWORD 
 ; server 
;API
RpcMgmtInqStats PROTO :DWORD ,:DWORD 
 ; server 
;API
RpcMgmtIsServerListening PROTO :DWORD 
 ; server 
;API
RpcMgmtStopServerListening PROTO :DWORD 
 ; server 
;API
RpcMgmtWaitServerListen PROTO :DWORD 
 ; server 
;API
RpcMgmtSetServerStackSize PROTO :DWORD 
 ; server 
;API
RpcSsDontSerializeContext PROTO :DWORD 
 ; client 
;API
RpcMgmtEnableIdleCleanup PROTO :DWORD 
;API
RpcMgmtInqIfIds PROTO :DWORD ,:DWORD 
;API
RpcIfIdVectorFree PROTO :DWORD 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcMgmtInqServerPrincNameA PROTO :DWORD ,:DWORD ,:DWORD 
;API
RpcMgmtInqServerPrincNameW PROTO :DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcMgmtInqServerPrincName	equ	<RpcMgmtInqServerPrincNameW>
ELSE
RpcMgmtInqServerPrincName	equ	<RpcMgmtInqServerPrincNameA>
ENDIF  ; UNICODE 
ELSE
;API
RpcMgmtInqServerPrincName PROTO :DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcServerInqDefaultPrincNameA PROTO :DWORD ,:DWORD 
;API
RpcServerInqDefaultPrincNameW PROTO :DWORD ,:DWORD 
IFDEF UNICODE
RpcServerInqDefaultPrincName	equ	<RpcServerInqDefaultPrincNameW>
ELSE
RpcServerInqDefaultPrincName	equ	<RpcServerInqDefaultPrincNameA>
ENDIF  ; UNICODE 
ELSE
;API
RpcServerInqDefaultPrincName PROTO :DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
 ; client 
;API
RpcEpResolveBinding PROTO :DWORD ,:DWORD 
 ; client 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcNsBindingInqEntryNameA PROTO :DWORD ,:DWORD ,:DWORD 
;API
RpcNsBindingInqEntryNameW PROTO :DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcNsBindingInqEntryName	equ	<RpcNsBindingInqEntryNameW>
ELSE
RpcNsBindingInqEntryName	equ	<RpcNsBindingInqEntryNameA>
ENDIF  ; UNICODE 
ELSE
;API
RpcNsBindingInqEntryName PROTO :DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
RPC_C_AUTHN_LEVEL_DEFAULT	equ	<0>
RPC_C_AUTHN_LEVEL_NONE	equ	<1>
RPC_C_AUTHN_LEVEL_CONNECT	equ	<2>
RPC_C_AUTHN_LEVEL_CALL	equ	<3>
RPC_C_AUTHN_LEVEL_PKT	equ	<4>
RPC_C_AUTHN_LEVEL_PKT_INTEGRITY	equ	<5>
RPC_C_AUTHN_LEVEL_PKT_PRIVACY	equ	<6>
RPC_C_IMP_LEVEL_DEFAULT	equ	<0>
RPC_C_IMP_LEVEL_ANONYMOUS	equ	<1>
RPC_C_IMP_LEVEL_IDENTIFY	equ	<2>
RPC_C_IMP_LEVEL_IMPERSONATE	equ	<3>
RPC_C_IMP_LEVEL_DELEGATE	equ	<4>
RPC_C_QOS_IDENTITY_STATIC	equ	<0>
RPC_C_QOS_IDENTITY_DYNAMIC	equ	<1>
RPC_C_QOS_CAPABILITIES_DEFAULT	equ	<00h>
RPC_C_QOS_CAPABILITIES_MUTUAL_AUTH	equ	<01h>
RPC_C_QOS_CAPABILITIES_MAKE_FULLSIC	equ	<02h>
RPC_C_QOS_CAPABILITIES_ANY_AUTHORITY	equ	<04h>
RPC_C_QOS_CAPABILITIES_IGNORE_DELEGATE_FAILURE	equ	<08h>
RPC_C_QOS_CAPABILITIES_LOCAL_MA_HINT	equ	<010h>
RPC_C_PROTECT_LEVEL_DEFAULT	equ	<RPC_C_AUTHN_LEVEL_DEFAULT>
RPC_C_PROTECT_LEVEL_NONE	equ	<RPC_C_AUTHN_LEVEL_NONE>
RPC_C_PROTECT_LEVEL_CONNECT	equ	<RPC_C_AUTHN_LEVEL_CONNECT>
RPC_C_PROTECT_LEVEL_CALL	equ	<RPC_C_AUTHN_LEVEL_CALL>
RPC_C_PROTECT_LEVEL_PKT	equ	<RPC_C_AUTHN_LEVEL_PKT>
RPC_C_PROTECT_LEVEL_PKT_INTEGRITY	equ	<RPC_C_AUTHN_LEVEL_PKT_INTEGRITY>
RPC_C_PROTECT_LEVEL_PKT_PRIVACY	equ	<RPC_C_AUTHN_LEVEL_PKT_PRIVACY>
RPC_C_AUTHN_NONE	equ	<0>
RPC_C_AUTHN_DCE_PRIVATE	equ	<1>
RPC_C_AUTHN_DCE_PUBLIC	equ	<2>
RPC_C_AUTHN_DEC_PUBLIC	equ	<4>
RPC_C_AUTHN_GSS_NEGOTIATE	equ	<9>
RPC_C_AUTHN_WINNT	equ	<10>
RPC_C_AUTHN_GSS_SCHANNEL	equ	<14>
RPC_C_AUTHN_GSS_KERBEROS	equ	<16>
RPC_C_AUTHN_DPA	equ	<17>
RPC_C_AUTHN_MSN	equ	<18>
RPC_C_AUTHN_DIGEST	equ	<21>
RPC_C_AUTHN_MQ	equ	<100>
RPC_C_AUTHN_DEFAULT	equ	<0FFFFFFFFh>
RPC_C_NO_CREDENTIALS	equ	<MAXUINT_PTR>
RPC_C_SECURITY_QOS_VERSION	equ	<1>
RPC_C_SECURITY_QOS_VERSION_1	equ	<1>

RPC_SECURITY_QOS	STRUCT
	Version DWORD ?
	Capabilities DWORD ?
	IdentityTracking DWORD ?
	ImpersonationType DWORD ?

RPC_SECURITY_QOS		ENDS

IFNDEF _AUTH_IDENTITY_DEFINED
SEC_WINNT_AUTH_IDENTITY_ANSI	equ	<01h>
SEC_WINNT_AUTH_IDENTITY_UNICODE	equ	<02h>

SEC_WINNT_AUTH_IDENTITY_W	STRUCT
	User DWORD ?
	UserLength DWORD ?
	Domain DWORD ?
	DomainLength DWORD ?
	Password DWORD ?
	PasswordLength DWORD ?
	Flags DWORD ?

SEC_WINNT_AUTH_IDENTITY_W		ENDS


SEC_WINNT_AUTH_IDENTITY_A	STRUCT
	User DWORD ?
	UserLength DWORD ?
	Domain DWORD ?
	DomainLength DWORD ?
	Password DWORD ?
	PasswordLength DWORD ?
	Flags DWORD ?

SEC_WINNT_AUTH_IDENTITY_A		ENDS

IFDEF UNICODE
SEC_WINNT_AUTH_IDENTITY	equ	<SEC_WINNT_AUTH_IDENTITY_W>
PSEC_WINNT_AUTH_IDENTITY	equ	<PSEC_WINNT_AUTH_IDENTITY_W>
_SEC_WINNT_AUTH_IDENTITY	equ	<_SEC_WINNT_AUTH_IDENTITY_W>
ELSE
SEC_WINNT_AUTH_IDENTITY	equ	<SEC_WINNT_AUTH_IDENTITY_A>
PSEC_WINNT_AUTH_IDENTITY	equ	<PSEC_WINNT_AUTH_IDENTITY_A>
_SEC_WINNT_AUTH_IDENTITY	equ	<_SEC_WINNT_AUTH_IDENTITY_A>
ENDIF  ; UNICODE
RPC_C_SECURITY_QOS_VERSION_2	equ	<2>
RPC_C_AUTHN_INFO_TYPE_HTTP	equ	<1>
RPC_C_HTTP_AUTHN_TARGET_SERVER	equ	<1>
RPC_C_HTTP_AUTHN_TARGET_PROXY	equ	<2>
RPC_C_HTTP_AUTHN_SCHEME_BASIC	equ	<000000001h>
RPC_C_HTTP_AUTHN_SCHEME_NTLM	equ	<000000002h>
RPC_C_HTTP_AUTHN_SCHEME_PASSPORT	equ	<000000004h>
RPC_C_HTTP_AUTHN_SCHEME_DIGEST	equ	<000000008h>
RPC_C_HTTP_AUTHN_SCHEME_NEGOTIATE	equ	<000000010h>
RPC_C_HTTP_AUTHN_SCHEME_CERT	equ	<000010000h>
 ; 0x00020000 & 0x00040000 are reserved
RPC_C_HTTP_FLAG_USE_SSL	equ	<1>
RPC_C_HTTP_FLAG_USE_FIRST_AUTH_SCHEME	equ	<2>
RPC_C_HTTP_FLAG_IGNORE_CERT_CN_INVALID	equ	<8>

RPC_HTTP_TRANSPORT_CREDENTIALS_W	STRUCT
	TransportCredentials DWORD ?
	Flags DWORD ?
	AuthenticationTarget DWORD ?
	NumberOfAuthnSchemes DWORD ?
	AuthnSchemes DWORD ?
	ServerCertificateSubject DWORD ?

RPC_HTTP_TRANSPORT_CREDENTIALS_W		ENDS


RPC_HTTP_TRANSPORT_CREDENTIALS_A	STRUCT
	TransportCredentials DWORD ?
	Flags DWORD ?
	AuthenticationTarget DWORD ?
	NumberOfAuthnSchemes DWORD ?
	AuthnSchemes DWORD ?
	ServerCertificateSubject DWORD ?

RPC_HTTP_TRANSPORT_CREDENTIALS_A		ENDS


RPC_SECURITY_QOS_V2_W	STRUCT
	Version DWORD ?
	Capabilities DWORD ?
	IdentityTracking DWORD ?
	ImpersonationType DWORD ?
	AdditionalSecurityInfoType DWORD ?
	union	u
	HttpCredentials DWORD ?
	ENDS

RPC_SECURITY_QOS_V2_W		ENDS


RPC_SECURITY_QOS_V2_A	STRUCT
	Version DWORD ?
	Capabilities DWORD ?
	IdentityTracking DWORD ?
	ImpersonationType DWORD ?
	AdditionalSecurityInfoType DWORD ?
	union	u
	HttpCredentials DWORD ?
	ENDS

RPC_SECURITY_QOS_V2_A		ENDS

RPC_C_SECURITY_QOS_VERSION_3	equ	<3>

RPC_SECURITY_QOS_V3_W	STRUCT
	Version DWORD ?
	Capabilities DWORD ?
	IdentityTracking DWORD ?
	ImpersonationType DWORD ?
	AdditionalSecurityInfoType DWORD ?
	union	u
	HttpCredentials DWORD ?
	ENDS
	Sid DWORD ?

RPC_SECURITY_QOS_V3_W		ENDS


RPC_SECURITY_QOS_V3_A	STRUCT
	Version DWORD ?
	Capabilities DWORD ?
	IdentityTracking DWORD ?
	ImpersonationType DWORD ?
	AdditionalSecurityInfoType DWORD ?
	union	u
	HttpCredentials DWORD ?
	ENDS
	Sid DWORD ?

RPC_SECURITY_QOS_V3_A		ENDS

ENDIF  ;_AUTH_IDENTITY_DEFINED
IFDEF UNICODE
RPC_SECURITY_QOS_V2	equ	<RPC_SECURITY_QOS_V2_W>
PRPC_SECURITY_QOS_V2	equ	<PRPC_SECURITY_QOS_V2_W>
_RPC_SECURITY_QOS_V2	equ	<_RPC_SECURITY_QOS_V2_W>
RPC_HTTP_TRANSPORT_CREDENTIALS	equ	<RPC_HTTP_TRANSPORT_CREDENTIALS_W>
PRPC_HTTP_TRANSPORT_CREDENTIALS	equ	<PRPC_HTTP_TRANSPORT_CREDENTIALS_W>
_RPC_HTTP_TRANSPORT_CREDENTIALS	equ	<_RPC_HTTP_TRANSPORT_CREDENTIALS_W>
RPC_SECURITY_QOS_V3	equ	<RPC_SECURITY_QOS_V3_W>
PRPC_SECURITY_QOS_V3	equ	<PRPC_SECURITY_QOS_V3_W>
_RPC_SECURITY_QOS_V3	equ	<_RPC_SECURITY_QOS_V3_W>
ELSE
RPC_SECURITY_QOS_V2	equ	<RPC_SECURITY_QOS_V2_A>
PRPC_SECURITY_QOS_V2	equ	<PRPC_SECURITY_QOS_V2_A>
_RPC_SECURITY_QOS_V2	equ	<_RPC_SECURITY_QOS_V2_A>
RPC_HTTP_TRANSPORT_CREDENTIALS	equ	<RPC_HTTP_TRANSPORT_CREDENTIALS_A>
PRPC_HTTP_TRANSPORT_CREDENTIALS	equ	<PRPC_HTTP_TRANSPORT_CREDENTIALS_A>
_RPC_HTTP_TRANSPORT_CREDENTIALS	equ	<_RPC_HTTP_TRANSPORT_CREDENTIALS_A>
RPC_SECURITY_QOS_V3	equ	<RPC_SECURITY_QOS_V3_A>
PRPC_SECURITY_QOS_V3	equ	<PRPC_SECURITY_QOS_V3_A>
_RPC_SECURITY_QOS_V3	equ	<_RPC_SECURITY_QOS_V3_A>
ENDIF  ; UNICODE

;RPC_HTTP_REDIRECTOR_STAGE	UNION
	RPCHTTP_RS_REDIRECT	EQU 1 
	RPCHTTP_RS_ACCESS_1	EQU 02H
	RPCHTTP_RS_SESSION	EQU 03H
	RPCHTTP_RS_ACCESS_2	EQU 04H
	RPCHTTP_RS_INTERFACE	EQU 05H
;RPC_HTTP_REDIRECTOR_STAGE		ENDS


RPC_NEW_HTTP_PROXY_CHANNEL PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
RPC_HTTP_PROXY_FREE_STRING PROTO :DWORD 
RPC_C_AUTHZ_NONE	equ	<0>
RPC_C_AUTHZ_NAME	equ	<1>
RPC_C_AUTHZ_DCE	equ	<2>
RPC_C_AUTHZ_DEFAULT	equ	<0ffffffffh>
;API
RpcImpersonateClient PROTO :DWORD 
;API
RpcRevertToSelfEx PROTO :DWORD 
;API
RpcRevertToSelf PROTO 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcBindingInqAuthClientA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthClientW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthClientExA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthClientExW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthInfoA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthInfoW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingSetAuthInfoA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingSetAuthInfoExA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingSetAuthInfoW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingSetAuthInfoExW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthInfoExA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthInfoExW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
RPC_AUTH_KEY_RETRIEVAL_FN PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerRegisterAuthInfoA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerRegisterAuthInfoW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcBindingInqAuthClient	equ	<RpcBindingInqAuthClientW>
RpcBindingInqAuthClientEx	equ	<RpcBindingInqAuthClientExW>
RpcBindingInqAuthInfo	equ	<RpcBindingInqAuthInfoW>
RpcBindingSetAuthInfo	equ	<RpcBindingSetAuthInfoW>
RpcServerRegisterAuthInfo	equ	<RpcServerRegisterAuthInfoW>
RpcBindingInqAuthInfoEx	equ	<RpcBindingInqAuthInfoExW>
RpcBindingSetAuthInfoEx	equ	<RpcBindingSetAuthInfoExW>
ELSE
RpcBindingInqAuthClient	equ	<RpcBindingInqAuthClientA>
RpcBindingInqAuthClientEx	equ	<RpcBindingInqAuthClientExA>
RpcBindingInqAuthInfo	equ	<RpcBindingInqAuthInfoA>
RpcBindingSetAuthInfo	equ	<RpcBindingSetAuthInfoA>
RpcServerRegisterAuthInfo	equ	<RpcServerRegisterAuthInfoA>
RpcBindingInqAuthInfoEx	equ	<RpcBindingInqAuthInfoExA>
RpcBindingSetAuthInfoEx	equ	<RpcBindingSetAuthInfoExA>
ENDIF  ; UNICODE 
ELSE
;API
RpcBindingInqAuthClient PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthClientEx PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingInqAuthInfo PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcBindingSetAuthInfo PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
RPC_AUTH_KEY_RETRIEVAL_FN PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcServerRegisterAuthInfo PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
IF NOTDEFINED (_M_IA64) 

RPC_CLIENT_INFORMATION1	STRUCT
	UserName DWORD ?
	ComputerName DWORD ?
	Privilege WORD ?
	AuthFlags DWORD ?

RPC_CLIENT_INFORMATION1		ENDS

ENDIF 
;API
RpcBindingServerFromClient PROTO :DWORD ,:DWORD 
;API
RpcRaiseException PROTO :DWORD 
;API
RpcTestCancel PROTO 
;API
RpcServerTestCancel PROTO :DWORD 
;API
RpcCancelThread PROTO :DWORD 
;API
RpcCancelThreadEx PROTO :DWORD ,:DWORD 
 ; client/server 
;API
UuidCreate PROTO :DWORD 
 ; client/server 
;API
UuidCreateSequential PROTO :DWORD 
IFDEF RPC_UNICODE_SUPPORTED
 ; client/server 
;API
UuidToStringA PROTO :DWORD ,:DWORD 
 ; client/server 
;API
UuidFromStringA PROTO :DWORD ,:DWORD 
 ; client/server 
;API
UuidToStringW PROTO :DWORD ,:DWORD 
 ; client/server 
;API
UuidFromStringW PROTO :DWORD ,:DWORD 
IFDEF UNICODE
UuidFromString	equ	<UuidFromStringW>
UuidToString	equ	<UuidToStringW>
ELSE
UuidFromString	equ	<UuidFromStringA>
UuidToString	equ	<UuidToStringA>
ENDIF  ; UNICODE 
ELSE
 ; client/server 
;API
UuidToString PROTO :DWORD ,:DWORD 
 ; client/server 
;API
UuidFromString PROTO :DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
;API
UuidCompare PROTO :DWORD ,:DWORD ,:DWORD 
;API
UuidCreateNil PROTO :DWORD 
;API
UuidEqual PROTO :DWORD ,:DWORD ,:DWORD 
;API
UuidHash PROTO :DWORD ,:DWORD 
;API
UuidIsNil PROTO :DWORD ,:DWORD 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcEpRegisterNoReplaceA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcEpRegisterNoReplaceW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcEpRegisterA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcEpRegisterW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcEpRegisterNoReplace	equ	<RpcEpRegisterNoReplaceW>
RpcEpRegister	equ	<RpcEpRegisterW>
ELSE
RpcEpRegisterNoReplace	equ	<RpcEpRegisterNoReplaceA>
RpcEpRegister	equ	<RpcEpRegisterA>
ENDIF  ; UNICODE 
ELSE
;API
RpcEpRegisterNoReplace PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcEpRegister PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
;API
RpcEpUnregister PROTO :DWORD ,:DWORD ,:DWORD 
DCE_C_ERROR_STRING_LEN	equ	<256>
IFDEF RPC_UNICODE_SUPPORTED
;API
DceErrorInqTextA PROTO :DWORD ,:DWORD 
;API
DceErrorInqTextW PROTO :DWORD ,:DWORD 
IFDEF UNICODE
DceErrorInqText	equ	<DceErrorInqTextW>
ELSE
DceErrorInqText	equ	<DceErrorInqTextA>
ENDIF  ; UNICODE 
ELSE
;API
DceErrorInqText PROTO :DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
RPC_C_EP_ALL_ELTS	equ	<0>
RPC_C_EP_MATCH_BY_IF	equ	<1>
RPC_C_EP_MATCH_BY_OBJ	equ	<2>
RPC_C_EP_MATCH_BY_BOTH	equ	<3>
RPC_C_VERS_ALL	equ	<1>
RPC_C_VERS_COMPATIBLE	equ	<2>
RPC_C_VERS_EXACT	equ	<3>
RPC_C_VERS_MAJOR_ONLY	equ	<4>
RPC_C_VERS_UPTO	equ	<5>
;API
RpcMgmtEpEltInqBegin PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcMgmtEpEltInqDone PROTO :DWORD 
IFDEF RPC_UNICODE_SUPPORTED
;API
RpcMgmtEpEltInqNextA PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
;API
RpcMgmtEpEltInqNextW PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD ,:DWORD 
IFDEF UNICODE
RpcMgmtEpEltInqNext	equ	<RpcMgmtEpEltInqNextW>
ELSE
RpcMgmtEpEltInqNext	equ	<RpcMgmtEpEltInqNextA>
ENDIF  ; UNICODE 
ELSE
;API
RpcMgmtEpEltInqNext PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
ENDIF  ; RPC_UNICODE_SUPPORTED 
;API
RpcMgmtEpUnregister PROTO :DWORD ,:DWORD ,:DWORD ,:DWORD 
RPC_MGMT_AUTHORIZATION_FN PROTO :DWORD ,:DWORD ,:DWORD 
RPC_C_MGMT_INQ_IF_IDS	equ	<0>
RPC_C_MGMT_INQ_PRINC_NAME	equ	<1>
RPC_C_MGMT_INQ_STATS	equ	<2>
RPC_C_MGMT_IS_SERVER_LISTEN	equ	<3>
RPC_C_MGMT_STOP_SERVER_LISTEN	equ	<4>
;API
RpcMgmtSetAuthorizationFn PROTO :DWORD 
RPC_C_PARM_MAX_PACKET_LENGTH	equ	<1>
RPC_C_PARM_BUFFER_LENGTH	equ	<2>
RPC_IF_AUTOLISTEN	equ	<00001h>
RPC_IF_OLE	equ	<00002h>
RPC_IF_ALLOW_UNKNOWN_AUTHORITY	equ	<00004h>
RPC_IF_ALLOW_SECURE_ONLY	equ	<00008h>
RPC_IF_ALLOW_CALLBACKS_WITH_NO_AUTH	equ	<00010h>
RPC_IF_ALLOW_LOCAL_ONLY	equ	<00020h>
RPC_IF_SEC_NO_CACHE	equ	<00040h>
;Include \masm32\sdk\rpcdcep.SDK
IFDEF __cplusplus
ENDIF 
ENDIF  ; __RPCDCE_H__ 
